/* PROGRAM to build files for sltc doc retrieval */
/* data structs for slatec documentation */

#if defined ultrix || defined _AIX
#include <sys/file.h>
#else
#include <sys/fcntl.h>
#endif
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#ifndef _AIX
#include <unistd.h>
#define W_ACC W_OK
#else
#include <sys/access.h>
#endif
#include <malloc.h>

#define SEEKRTN(fp,j) fseek( fp,(long)(r[j].a.rstart),0);
#define KEYLN 56
#define GAMLN 12
#define NGAMS 739
#define RTNLN 8
#define BFSZ 256
#define CDLN 72
#define NRTN 2000

#define MXKEY  63
#define MXGAMS 63
#define MXCALL 63

#define DCKLN 5
#define KYLN 12
#define KELN 4
#define ENDLN 16
#define CALLN 19
#define NOENTRY 32767

/*
/* 4+4+4+4+8 = 24 */
/* assumes start index into short array with <64k
  entries which are indexes to keys,calls,gams...
  gam entries at start of the array.
  key entries next.
  IF ngams,nkeys,or ncalls = 0 then index taken as direct
  index instead. If its set to 32k-1 taken to be NOENTRY
  u0,u1 reserved for future use.
*/
struct routine{

  struct {
  unsigned int rstart: 26; /* max 64M */
  unsigned int u0: 6;      /* max 63  */
  }a;

  struct {
  unsigned int start : 15;    /* max 32k  */
  unsigned int n:  6;         /* max 63   */
  unsigned int doclines: 11;  /* max 2047 */
  }g;
  
  struct {
  unsigned int start :  15;   /* max 32k  */
  unsigned int n :  6;        /* max 63   */
  unsigned int srclines: 11;  /* max 2047 */
  }k;

  struct {
  unsigned int start : 15;    /* max 32k */
  unsigned int n : 6;         /* max 63  */
  unsigned int npurpose:  3;  /* max 7   */
  unsigned int purpose :  4;  /* max 15  */
  unsigned int type: 2;
  unsigned int u2: 1;
  }c;
   
  char name[RTNLN];   /* 8 bytes */
};

struct gams{
  char gam[GAMLN];
  char* describe;
};

struct commn{
unsigned int start :  15;   /* max 32k */
unsigned int n :  6;        /* max 63 */
unsigned int srclines: 11;  /* max 2047 */
};

/*
   DAF -- concatenated slatec doc and source
   GAMS - ascii database of GAMS categories
   RTBL - binary database containing array of routine structures
   KYWDS- ascii database of keyword phrases
   NDX -- binary database -- array of short indices
*/

#define  DAF "/usr/um/generic/slatec/lib/slainp"
#define GAMS "/usr/caen/doc/slatec/v4/gams"

#define KYWDS "/usr/caen/doc/slatec/v4/keywords"
#define RTBL "/usr/um/generic/slatec/lib/rtbl"
#define NDX "/usr/um/generic/slatec/lib/ndx"

